// Unicode.h
//
// Copyright (C) 2000 by Jerry Lozano
//
//

#pragma once


class CUString {
public:
    CUString() {Init(); }    // Konstruktor, nimmt Init-Methode in Anspruch
    CUString(const char* pAnsiString);
    CUString(PCWSTR pWideString);
    ~CUString();             // Destruktor, nimmt Free-Methode in Anspruch
    void Init();             // Initialisiert Struktur
    void Free();             // Reiniialisiert Struktur und gibt Puffer frei
    CUString(const CUString& orig); // Copy-Konstruktor (erforderlich)
    CUString operator=(const CUString& rop);  // Zuweisungsoperator (erforderlich)
    BOOLEAN operator==(const CUString& rop) const;  // berladener Vergleichsoperator 
    CUString operator+(const CUString& rop) const;  // Verkettungsoperator 
	CUString& operator+=(const CUString& rop);	// und noch die bequeme Verkettung
    operator PWSTR() const;  // Cast-Operator nach wchar_t
    operator UNICODE_STRING&();	// cast nach UNICODE_STRING
    operator ULONG() const;  // Cast-Operator nach ULONG
    CUString(ULONG value);   // Konvertiert ULONG->CUString
    WCHAR& operator[](int idx);  // Array-Operator fr Pufferzugriff
    USHORT Length() {return uStr.Length/2;} // Zeichenanzahl

protected:
    UNICODE_STRING uStr;     // W2K-Kernel-Format fr Unicode-Strings
    enum ALLOC_TYPE {Empty, FromCode, FromPaged, FromNonPaged};
    ALLOC_TYPE  aType;       // Speicherart fr Puffer 
};
